// Autor: Goran Zuzic

#include <algorithm>

#include <cassert>
#include <cstdio>
#include <cstdlib>
#include <cstring>

#include <string>
#include <vector>
#include <iostream>

using namespace std;

#define REP(i, n) FOR(i, 0, n)
#define FOR(i, a, b) for (int i = (a); i < (b); ++i)
#define TRACE(x) cout << #x << " = " << (x) << endl

typedef long long llint;

const int MAXN = 1234;
char grid[MAXN][MAXN];

int main(void)
{
  int R, S; scanf("%d %d", &R, &S);
  REP(i, R) scanf("%s", grid[i]);

  int n_in; scanf("%d", &n_in);
  REP(i_in, n_in) {
    int y; scanf("%d", &y); --y;
    int x = 0;

    while (true) {
      if (x+1 == R || grid[x+1][y] == '#') break;
      // dakle x+1 < R i ispod nije #
      if (grid[x+1][y] == 'o') {
        if (y+1 < S && grid[x][y+1] == '.' && grid[x+1][y+1] == '.') { ++x; ++y; continue; }
        if (y-1 >= 0 && grid[x][y-1] == '.' && grid[x+1][y-1] == '.') { ++x; --y; continue; }
        break;
      } else if (grid[x+1][y] == '.') {
        ++x;
        continue;
      }
    }

    grid[x][y] = 'o';
  }

  REP(i, R) puts(grid[i]);
  return 0;
}
