// Autor: Gustav Matula

#include <cstdio>
#include <cstring>
#include <cassert>

#define MAX 55

int R, S, K;
int A, B;
char m[MAX][MAX];

int main(void)
{
  scanf("%d%d%d", &R, &S, &K);

  memset(m, '.', sizeof m);

  for (int i = 0; i < K; ++i) {
    scanf("%d%d", &A, &B);

    bool done = false;
    int x, y, ny, nx;
    for (x = 0; x < R; ++x) {
      for (y = 0; y + B <= S; ++y) {
        ny = y + 1;
        nx = x + 1;
        if (m[x][y] != '.') continue;

        while (ny < S && m[x][ny] == '.') ++ny;
        while (nx < R && m[nx][y] == '.') ++nx;

        if (nx - x >= A && ny - y >= B) { done = true; break; }
      }
      if (done) break;
    }

    for (int r = 0; r < A; ++r) {
      for (int c = 0; c < B; ++c) {
        if (r == 0 || r == A - 1)
          m[x + r][y + c] = '-';
        else if (c == 0 || c == B - 1)
          m[x + r][y + c] = '|';
        else
          m[x + r][y + c] = '#';
      }
    }

    m[x][y] = m[x + A - 1][y + B - 1] = '+';
    m[x + A - 1][y] = m[x][y + B - 1] = '+';
  }

  for (int i = 0; i < R; ++i) {
    for (int j = 0; j < S; ++j) {
      putchar(m[i][j]);
    }
    putchar('\n');
  }

  return 0;
}
